VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ClsEncoderLog"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'logs encoder values and then converts them into lines
'
'Encoder logs are stored in 8 bit entrees as differential counts
'larger records record the full number
'A full log is used to set the current map position
'
'
'The first log is the current location and
'the second log is the start of the log file
'
'
'Map cordinates are 0,0 at lower left
' MapX#Y# = inches from lower left
' MapA# = angle in radians
'
'uses
'   Public g_BotEncoderR#   'Right Encoder counts per inch
'   Public g_BotEncoderL#   'Left Encoder counts per inch
'   Public g_BotWheelDistance#   'for Encoder use
'
'   Public g_MapImageDPIX#  'image DPI for path calculation
'   Public g_MapImageDPIY#  'image DPI for path calculation

Dim m_FileName As String
Dim m_FileHandle As Integer

Event Update()

Public EncoderR&, EncoderL&, MapX#, MapY#, MapA#

Dim FileWritePtr&
Dim m_ElogHeadder As EncoderHeadderType
'

'cached for redraw
Dim m_BotEncoderR#   'Right Encoder counts per inch
Dim m_BotEncoderL#   'Left Encoder counts per inch
Dim m_BotWheelDistance#   'for Encoder use
Dim PathXY() As PointS, PathXYOld As PointS
Dim PathXYLen&
Dim PathXYPoints&
'
'

Private Sub Class_Initialize()
'
    m_FileName = ""
    m_FileHandle = 0
    EncoderR& = 0
    EncoderL& = 0
    FileWritePtr& = 0
    PathXYPoints& = 0
    PathXYLen& = 0
    PathXYOld.x = 0
    PathXYOld.y = 0
    
End Sub

Private Sub Class_Terminate()
    Call CloseFile
End Sub

Public Property Get filename() As String
    filename = m_FileName
End Property
Public Property Let filename(NewName As String)
    If m_FileName <> NewName Then
        Call CloseFile
        m_FileName = NewName
        Call OpenFile
    End If
End Property
Private Sub OpenFile()
    m_FileHandle = FreeFile
    Open m_FileName For Binary As m_FileHandle
    '
    Dim l&
    l& = LOF(m_FileHandle)
    If l& > 0 Then
        'read headder
        Get #m_FileHandle, , m_ElogHeadder
        Seek #m_FileHandle, l& + 1
        FileWritePtr& = l& + 1
    Else
        m_ElogHeadder.FileIdent = "ELOG"
        m_ElogHeadder.TNow = Now
        m_ElogHeadder.Version = 1 'map points in pixels
        m_ElogHeadder.flags = 0
        m_ElogHeadder.WayPoints = 0
        
        FileWritePtr& = Len(m_ElogHeadder) + 1
        Call AddEncoderWayPoint(0, 0, 0)
    End If
    
End Sub
Private Sub CloseFile()
    If m_FileHandle Then
        
        m_ElogHeadder.FileIdent = "ELOG"
        m_ElogHeadder.TNow = Now
        m_ElogHeadder.flags = 0
        
        Put #m_FileHandle, 1, m_ElogHeadder
        
        Close m_FileHandle
        m_FileHandle = 0
    End If
End Sub

Public Sub AddEncoderLog(r&, l&)
    Dim bL As EncoderByteLogType
    Dim FL As EncoderFulLogType
    Dim Changed As Boolean
    Changed = False
    If m_FileHandle Then
        If (r& <> EncoderR&) Or (l& <> EncoderL&) Then
            Changed = True
            If Abs(r& - EncoderR&) <= 127 And Abs(l& - EncoderL&) <= 127 Then
                Dim Rb%, Lb%
                Rb% = r& - EncoderR&
                Lb% = l& - EncoderL&
                bL.bR = Rb% And &HFF   'signed -127 to +127
                bL.bL = Lb% And &HFF
                Put #m_FileHandle, FileWritePtr&, bL
                FileWritePtr& = FileWritePtr& + Len(bL)
            Else
                bL.bR = &H80            '(-128 means next record is.. )
                bL.bL = 0               '(0=FullLog)
                Put #m_FileHandle, FileWritePtr&, bL
                FileWritePtr& = FileWritePtr& + Len(bL)
                FL.lR = r& - EncoderR&
                FL.lL = l& - EncoderL&
                Put #m_FileHandle, FileWritePtr&, FL
                FileWritePtr& = FileWritePtr& + Len(FL)
            End If 'large change
        End If 'change
    End If 'file open
    '
    '
    'Adjust map
    
    'PathXYPoints&
    If Changed Then
        Dim ER&, EL&, pntsOld&
        ER& = r& - EncoderR&
        EL& = l& - EncoderL&
        pntsOld& = PathXYPoints&
        Call AdjustMap(ER&, EL&, 0)
        If PathXYPoints& <> pntsOld& Then RaiseEvent Update
        
    End If
    
    EncoderR& = r&
    EncoderL& = l&
End Sub

Public Sub AddEncoderWayPoint(ByVal nMapX!, ByVal nMapY!, ByVal nMapA!)
    Dim bL As EncoderByteLogType
    Dim wp As EncoderWPLogType
    bL.bR = &H80            '(-128 means next record is.. )
    bL.bL = 1               '(1=Waypoint)
    Put #m_FileHandle, FileWritePtr&, bL
    FileWritePtr& = FileWritePtr& + Len(bL)
                
    wp.flags = 0
    wp.wp = m_ElogHeadder.WayPoints
    If m_ElogHeadder.Version = 0 Then
        wp.MapX = nMapX!
        wp.MapY = nMapY!
    Else
        wp.MapX = nMapX! * g_MapImageDPIX# 'convert to pixels
        wp.MapY = nMapY! * g_MapImageDPIY#
    End If
    wp.MapA = nMapA!
    
    wp.TNow = Now
    
    Put #m_FileHandle, FileWritePtr&, wp
    FileWritePtr& = FileWritePtr& + Len(wp)
    
    m_ElogHeadder.WayPoints = m_ElogHeadder.WayPoints + 1
    
    Call RecalculatePath
    
End Sub

Public Sub DrawPath(p1 As PictureBox, x%, y%)
'x%,y% = lower left 0,0 cordinates
'DPIX#,Y# = DotsPerInch of image

    If m_FileHandle Then
        If (m_BotEncoderR# <> g_BotEncoderR#) Or _
        (m_BotEncoderL# <> g_BotEncoderL#) Or _
        (m_BotWheelDistance# <> g_BotWheelDistance#) Then 'Re-read file
        
            Call RecalculatePath
        
        End If 'changed
    End If 'file open
    
    If PathXYPoints& Then
        'draw path
        Dim i&, xnew%, yNew%, xold%, yold%
        xold% = 0: yold% = 0
        For i& = 0 To PathXYPoints& - 1
            xnew% = PathXY(i).x
            yNew% = PathXY(i).y
            If ((xnew% <> 0) Or (yNew% <> 0)) And ((xold% <> 0) Or (yold% <> 0)) Then
                p1.Line (xnew% + x%, y% - yNew%)-(xold% + x%, y% - yold%), RGB(255, 0, 0)
            End If
            xold% = xnew%
            yold% = yNew%
                
        Next
    End If 'PathXYPoints
End Sub


Public Sub RecalculatePath()
'
'uses
'
    If m_FileHandle Then
        'If (m_BotEncoderR# <> g_BotEncoderR#) Or _
        '(m_BotEncoderL# <> g_BotEncoderL#) Or _
        '(m_BotWheelDistance# <> g_BotWheelDistance#) Then 'Re-read file
            m_BotEncoderR# = g_BotEncoderR#
            m_BotEncoderL# = g_BotEncoderL#
            m_BotWheelDistance# = g_BotWheelDistance#
            PathXYPoints& = 0
            Dim bL As EncoderByteLogType, FL As EncoderFulLogType, wp As EncoderWPLogType
            
            Dim FLen&, Fpos&, ER&, EL&, RType% ', Deg2Rad#
            
            MapX# = 0: MapY# = 0: MapA# = 0
            FLen& = LOF(m_FileHandle)
            Fpos& = Len(m_ElogHeadder) + 1
            'Deg2Rad# = 3.141592654 / 180
            If PathXYLen < 100 Then
                ReDim PathXY(100)
                PathXYLen = 100
            End If
            PathXY(0).x = 0
            PathXY(0).y = 0
            Do
                If Fpos& > FLen& Then Exit Do
                Get #m_FileHandle, Fpos&, bL
                Fpos& = Fpos& + Len(bL)
                ER& = 0: EL& = 0: RType% = 0
                If bL.bR = &H80 Then
                    
                    If bL.bL = 0 Then
                        Get #m_FileHandle, Fpos&, FL
                        Fpos& = Fpos& + Len(FL)
                        ER& = FL.lR
                        EL& = FL.lL
                    ElseIf bL.bL = 1 Then
                        RType% = 1
                        Get #m_FileHandle, Fpos&, wp
                        Fpos& = Fpos& + Len(wp)
                        
                        If m_ElogHeadder.Version = 0 Then
                            MapX# = wp.MapX
                            MapY# = wp.MapY
                        Else
                            If g_MapImageDPIX# > 0 Then
                                MapX# = wp.MapX / g_MapImageDPIX#
                                MapY# = wp.MapY / g_MapImageDPIY#
                            End If
                        End If
                        MapA# = wp.MapA
                    End If
                Else
                    ER& = bL.bR
                    If ER& > 127 Then ER& = ER& Or &HFFFFFF00
                    EL& = bL.bL
                    If EL& > 127 Then EL& = EL& Or &HFFFFFF00
                    
                End If
                
                'MapX#, MapY#, MapA#
                Call AdjustMap(ER&, EL&, RType%)
                

            Loop
           
    End If 'file open
    
    RaiseEvent Update
End Sub

Private Sub AdjustMap(ER&, EL&, RType%)
'EL,ER = delta encoder counts
'
'
    Dim DR#, DL#, DCntr#, xm%, ym%
    If RType% = 1 Then
        xm% = 0
        ym% = 0
    Else
        'adjust MapX,MapY,MapA using ER&,EL&
        '1 Convert to inches
        DR# = ER& / m_BotEncoderR#  'counts per inch
        DL# = EL& / m_BotEncoderL#
        'Figure angle change. increse Angle when turning CW
        MapA# = MapA# + (((((DL# - DR#)) / (g_BotWheelDistance#)) * (3.14 / 2)))
                        
        'figure distance center of bot traveled
        DCntr# = (DR# + DL#) / 2
        'move map pos
        MapX# = MapX# + (DCntr# * Sin(MapA)) '90=east
        MapY# = MapY# + (DCntr# * Cos(MapA)) '0=north
        'convert to pixels
        xm% = MapX# * g_MapImageDPIX#
        ym% = MapY# * g_MapImageDPIY#
    End If
    'add to point array
    
    If (PathXYOld.x <> xm%) Or (PathXYOld.y <> ym%) Or (RType% = 1) Then
        PathXY(PathXYPoints&).x = xm%
        PathXY(PathXYPoints&).y = ym%
        PathXYOld.x = xm%
        PathXYOld.y = ym%
    
        PathXYPoints& = PathXYPoints& + 1
        If PathXYLen <= PathXYPoints& Then
            ReDim Preserve PathXY(PathXYPoints& + 100)
            PathXYLen = PathXYPoints& + 100
        End If
    End If 'pixel changed

End Sub






