VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ClsINIFile"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'
'
'Reads and saves data from Ini files
'
'Usage
'1. call FileLoad
'2. Use GetString to get settings
'3. do stuff
'4. call FileLoad just in case the file has changed while program is running.
'5. Use SaveString to save settings
'6. Call FileSave to save file.
'
'
'GetAppPath = App.Path & "/"        'way to simple to have a function

Dim FileBufferFileName As String
Dim FileBuffer() As String   'file data
Dim FileBufferSize As Integer    'ubound of array
Dim FileBufferLines As Integer    'count
Dim FileBufferLoaded As Date        'for cache
Dim FileBufferModifyed As Boolean        'for cache

'
Private Sub Class_Initialize()
    FileBufferSize = 0
    FileBufferLines = 0
    FileBufferLoaded = 0
    FileBufferModifyed = False
End Sub

Private Sub Class_Terminate()
'
    'if FileBufferModifyed then
        'If they did not save then too bad!
    'end if
End Sub

'*******************************************************************************
Public Sub FileNew()

    FileBufferLines = 0
    FileBufferLoaded = 0
    FileBufferModifyed = False
End Sub

Public Sub FileLoad(ByVal filename$)
'purpose

'   To load a file into memory
'in
'   Filename = filename of INI file, or App.Path & "/" & app name, or blank for default
'returns
'   true of ok
'   false if error
'uses
'Dim FileBuffer$()    'file data
'Dim FileBufferSize As Integer    'ubound of array
'Dim FileBufferLines As Integer    'count
'Dim FileBufferLoaded As Date        'for cache
'Dim FileBufferModifyed As Boolean        'for cache

    Dim Filenum%
    Dim i%, sLine$
    
    'LoadFile = False
    FileBufferFileName$ = GetINIFileName(filename$)
    
    FileBufferLines = 0
    FileBufferLoaded = Now
    FileBufferModifyed = False
    
    On Error GoTo LFFileError       'if new file
    
    Filenum% = FreeFile
    Open FileBufferFileName$ For Input As Filenum%
    Do While (Not EOF(Filenum%))
        Line Input #Filenum%, sLine$
        If (FileBufferLines + 100) > FileBufferSize Then
            FileBufferSize = FileBufferLines + 100
            ReDim Preserve FileBuffer$(FileBufferSize)
        End If
        FileBuffer$(FileBufferLines) = sLine$
        FileBufferLines = FileBufferLines + 1
    Loop 'eof
    Close Filenum%
    
    'If FileBufferLines > 0 Then LoadFile = True     'we have at least one line
    
    Exit Sub
LFFileError:

End Sub
Public Sub FileSave(Optional ByVal filename$ = "")
'purpose
'   To save a file from memory
'in
'   Filename = filename of INI file or app name or blank for default
'uses
'Dim FileBuffer$()    'file data
'Dim FileBufferSize As Integer    'ubound of array
'Dim FileBufferLines As Integer    'count
'Dim FileBufferLoaded As Date        'for cache
'Dim FileBufferModifyed As Boolean        'for cache

    Dim Filenum%
    Dim i%
    
    If Len(filename$) > 0 Then
        FileBufferFileName$ = GetINIFileName(filename)  'Save As
    End If
       
    On Error GoTo SFFileError
    Filenum% = FreeFile
    Open FileBufferFileName$ For Output As Filenum%
    For i = 0 To FileBufferLines - 1
        Print #Filenum%, FileBuffer$(i)
    Next i
    Close Filenum%
    
    FileBufferModifyed = False
    
    Exit Sub
SFFileError:

End Sub

Public Function GetString(ByVal Section As String, ByVal Key As String, Optional ByVal default As String = "") As String
'purpose
'   To Get a string from the loaded file
'in
'   Section$ = name of section
'   Key      = name of key
'   default  = used if ket is not found or file error


    Dim i%, sLine$, Lnum%
    Dim ThisSection$, d$
    Dim ThisKey$, ThisVal$
    Dim KeySearch$, SectionSearch$
    
    KeySearch$ = UCase$(RTrim$(LTrim$(Key$)))
    SectionSearch$ = UCase$(RTrim$(LTrim$(Section$)))
    ThisSection$ = ""
        
    GetString = default
    
    If FileBufferLines = 0 Then Exit Function   'no file loaded
    
    For Lnum% = 0 To FileBufferLines - 1
        sLine$ = FileBuffer$(Lnum%)
    
        If Len(sLine$) Then
            d$ = Mid$(sLine$, 1, 1)
            
            If d$ = ";" Then
                'comment
            ElseIf d$ = "[" Then
                ThisSection$ = Mid$(sLine$, 2)
                i = InStr(ThisSection$, "]")
                If i Then ThisSection$ = Mid$(ThisSection$, 1, i - 1)
                ThisSection$ = UCase$(RTrim$(LTrim$(ThisSection$)))
                
            Else
                If ThisSection$ = SectionSearch$ Then
                    i = InStr(sLine$, "=")
                    If i Then
                        ThisKey$ = UCase$(RTrim$(LTrim$(Mid$(sLine$, 1, i - 1))))
                        If ThisKey$ = KeySearch$ Then
                            ThisVal$ = RTrim$(LTrim$(Mid$(sLine$, i + 1)))
                            'I found it
                            GetString = ThisVal$
                            Exit For
                            
                        End If 'KeySearch$
                    End If 'instr =
                End If ' ThisSection$
            End If '; or [?
        End If 'len
    Next 'Lnum%
  
End Function

Public Sub SaveString(ByVal Section As String, ByVal Key As String, ByVal Setting As String)
'purpose
'   to save a string to a key
'   cretes the key if not found
'Call Save to keep changes
'uses
'Dim FileBuffer$()    'file data
'Dim FileBufferSize As Integer    'ubound of array
'Dim FileBufferLines As Integer    'count
'Dim FileBufferLoaded As Date        'for cache
'Dim FileBufferModifyed As Boolean        'for cache


    Dim i%, Lnum%, sLine$
    Dim ThisSection$, d$
    Dim ThisKey$, ThisVal$
    Dim KeySearch$, SectionSearch$
    Dim foundKey As Boolean
    Dim SectionPointer As Integer
    
    '
    KeySearch$ = UCase$(RTrim$(LTrim$(Key$)))
    SectionSearch$ = UCase$(RTrim$(LTrim$(Section$)))
    ThisSection$ = ""
    foundKey = False
    SectionPointer = -1
    If FileBufferLines Then
        For Lnum% = 0 To FileBufferLines - 1
            sLine$ = FileBuffer$(Lnum%)
            If Len(sLine$) Then
                d$ = Mid$(sLine$, 1, 1)
                
                If d$ = ";" Then
                    'comment
                ElseIf d$ = "[" Then
                    ThisSection$ = Mid$(sLine$, 2)
                    i = InStr(ThisSection$, "]")
                    If i Then ThisSection$ = Mid$(ThisSection$, 1, i - 1)
                    ThisSection$ = UCase$(RTrim$(LTrim$(ThisSection$)))
                    
                Else
                    If ThisSection$ = SectionSearch$ Then
                        SectionPointer = Lnum%          'save for insert latter
                        i = InStr(sLine$, "=")
                        If i Then
                            ThisKey$ = UCase$(RTrim$(LTrim$(Mid$(sLine$, 1, i - 1))))
                            If ThisKey$ = KeySearch$ Then
                                'ThisVal$ = RTrim$(LTrim$(Mid$(sLine$, i + 1)))
                                foundKey = True 'I found it
                                FileBuffer$(Lnum%) = Key$ & " = " & RTrim$(LTrim$(Setting))
                                Exit For
                            End If 'KeySearch$
                        End If 'instr =
                    End If ' ThisSection$
                End If '; or [?
            End If 'len
        Next Lnum% ' i = 0 To FileBufferLines - 1
    End If 'FileBufferLines = 0
    If Not foundKey Then
        'add key to array
        If (FileBufferLines + 100) > FileBufferSize Then
            FileBufferSize = FileBufferLines + 100
            ReDim Preserve FileBuffer$(FileBufferSize)
        End If
        If SectionPointer >= 0 Then  ' SectionPointer points to last line in section
            'insert shift lines after pointer
            For i = FileBufferLines - 1 To SectionPointer + 1 Step -1
                FileBuffer$(i + 1) = FileBuffer$(i)
            Next i
            FileBufferLines = FileBufferLines + 1
            FileBuffer$(SectionPointer + 1) = Key & "=" & RTrim$(LTrim$(Setting))
        Else    'new section
            FileBuffer$(FileBufferLines) = "[" & Section & "]"
            FileBufferLines = FileBufferLines + 1
            FileBuffer$(FileBufferLines) = Key & "=" & RTrim$(LTrim$(Setting))
            FileBufferLines = FileBufferLines + 1
        
        End If 'SectionPointer
    End If 'not found key
        
    FileBufferModifyed = True
    
End Sub















'**********************************************************************
' helper functions
'***********************************************************************
'Public Function GetAppPath() As String
    'GetAppPath = App.Path & "/"        'way to simple to have a function
'End Function

Private Function FileExists(filename$) As Boolean
    '
    Dim Filenum%
    
    FileExists = False
    On Error GoTo FEFileError
    Filenum% = FreeFile
    Open filename$ For Input As Filenum%
    Close Filenum%
    FileExists = True

    Exit Function
FEFileError:

End Function

Private Function GetINIFileName(ByVal filename As String) As String

    Dim File$, Path$, INIFile$
    If Len(filename) = 0 Then
        INIFile$ = "settings.ini"
    Else
        Path$ = ConvertName2Path(filename)
        File$ = GetBaseFileNameByPath(filename)
        If InStr(File$, ".") Then File$ = Mid$(File$, 1, InStr(File$, ".") - 1)
        INIFile$ = Path$ & File$ & ".INI"
    End If
'if Filename
    GetINIFileName = INIFile$

End Function

Private Function GetBaseFileNameByPath(ByVal filename As String) As String
'
'Purpose: to get the Filename without the path
'c:\x\f.e >> f.e
   Dim P%, l%
   Dim Path$
   If InStr(filename, "\") Then ' path attatched?
      Path$ = ""
      Do
         P = InStr(filename, "\")
         If P Then
            Path$ = Path$ & Mid$(filename, 1, P)
            filename = Mid$(filename, P + 1)
         Else
            Exit Do
         End If
      Loop
   End If
   GetBaseFileNameByPath = filename

End Function



Private Function ConvertName2Path(ByVal filename As String) As String
'Purpose: to get the path with any required end "\"
'c:\x\f.e >> c:\x\
   Dim P%, l%
   Dim Path$
   Dim File$
   File$ = filename
   
   If InStr(File$, "\") Then ' path attatched?
      Path$ = ""
      Do
         P = InStr(File$, "\")
         If P Then
            Path$ = Path$ & Mid$(File$, 1, P)
            File$ = Mid$(File$, P + 1)
         Else
            Exit Do
         End If
      Loop
      ConvertName2Path = Path
   Else
      ConvertName2Path = "C:\Data\"  'error. use default
   End If
   
End Function




