VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Begin VB.Form FrmComPort 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "FrmComPort"
   ClientHeight    =   2340
   ClientLeft      =   4185
   ClientTop       =   3840
   ClientWidth     =   4905
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2340
   ScaleWidth      =   4905
   Visible         =   0   'False
   Begin VB.CommandButton BtnOk 
      Caption         =   "Ok"
      Height          =   375
      Left            =   3960
      TabIndex        =   1
      Top             =   1920
      Width           =   855
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   960
      Top             =   360
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
   End
   Begin VB.Timer Timer1 
      Interval        =   54
      Left            =   360
      Top             =   360
   End
   Begin VB.TextBox Text1 
      Height          =   1695
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Text            =   "FrmComPort.frx":0000
      Top             =   120
      Width           =   4695
   End
End
Attribute VB_Name = "FrmComPort"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'Purpose
'   To support ClsSerialPkt
'   Holds the MsComm1 control
'   Holds the timer control
'   Displays error messages
'
'Usage example
'   .BaudRate = 19200
'   .CommPort = 1
'   .PortOpen = true
'   if .PortOpen then
'       SendText("hello world")
'       dim dat(10) as Byte
'       ' fill dat()
'       SendData(dat(),10)
'   .PortOpen = false
'MyComPort_DataReceive(newData() As Byte, DataLen As Integer)
'   'do something with received data
'    SendData(newData(),DataLen) 'echo it?
'
'Notes:
'  You can set .BaudRate, .CommPort, and .PortOpen in any order
' and this code will open and close the port as needed.
'

Public Event Timer55()  'Trigered every 55 ms
Public Event OnComm()   'Triggered on the "OnComm" event

Public Event DataReceive(newData() As Byte, DataLen As Integer)
Public Event CommPortError(cEvent As Integer)

Dim MyBaudRate As Long

Private Sub Form_Load()
    MyBaudRate& = -1
    
End Sub

Private Sub Form_Unload(Cancel As Integer)
'
    If PortOpen Then PortOpen = False

End Sub

Private Sub BtnOk_Click()
    Me.Visible = False
End Sub

'**************************************************
Private Sub Timer1_Timer()
    RaiseEvent Timer55
End Sub

'*************************************************
Private Sub MSComm1_OnComm()
    RaiseEvent OnComm
    '****************************
    Dim cEvent As Integer
    cEvent = MSComm1.CommEvent
    Select Case cEvent
    Case comEventFrame, comEventBreak
        If MSComm1.PortOpen Then
            RaiseEvent CommPortError(cEvent)
         
            PortOpen = False   'cycle port to clear error
            PortOpen = True
            ' Sometimes framing errors can not be cleared unless
            ' the port is closed and reopened
         
        End If
    End Select
    
    If (MSComm1.InBufferCount) Then
        Dim d() As Byte
        d = MSComm1.Input
        RaiseEvent DataReceive(d(), UBound(d) + 1)
    End If
       
End Sub

Public Sub SetMessageText(Msg$) ' uses this form for messages
    Text1.Text = Msg$
    Me.Visible = True
End Sub

Public Sub SendText(Msg$)
    If MSComm1.PortOpen Then
        MSComm1.Output = Msg$
    End If
End Sub
Public Sub SendData(Dat() As Byte)
    If MSComm1.PortOpen Then
        MSComm1.Output = Dat()
    End If
End Sub
Public Sub SendDataWLen(Dat() As Byte, SendLen As Integer)
    If SendLen Then
        ReDim Dat2(SendLen - 1) As Byte
        Dim i%
        For i% = 0 To SendLen - 1
            Dat2(i) = Dat(i)
        Next i%
        If MSComm1.PortOpen Then
            MSComm1.Output = Dat2()
        End If
    End If
End Sub

'-------------- Port interface --------------------------
Public Property Get PortOpen() As Boolean
    PortOpen = MSComm1.PortOpen
End Property
Public Property Let PortOpen(ByVal vNewValue As Boolean)
    
    On Error GoTo OpenPortError
    
    If vNewValue Then 'open port
        If MSComm1.PortOpen = False Then
                    
            MSComm1.Settings = LTrim$(Str$(MyBaudRate)) & ",N,8,1"
            
            MSComm1.PortOpen = True 'open port
            If MSComm1.PortOpen Then ' we did open it
                MSComm1.RTSEnable = True 'false if IRP
                MSComm1.DTREnable = True 'device turned on
            
                MSComm1.InputMode = comInputModeBinary
                MSComm1.InputLen = 0
                MSComm1.RThreshold = 1 'oncom
            End If
        End If
    Else 'close port
        If MSComm1.PortOpen Then
            MSComm1.DTREnable = False   'turn off device
            MSComm1.RTSEnable = False
        
            MSComm1.PortOpen = False    'close port
        End If
    End If
Exit Property
OpenPortError:
   If MSComm1.PortOpen Then MSComm1.PortOpen = False

End Property

Public Property Get CommPort() As Integer
    CommPort = MSComm1.CommPort
End Property
Public Property Let CommPort(ByVal vNewValue As Integer)
    If (vNewValue <> MSComm1.CommPort) Then
        If PortOpen Then
            PortOpen = False
            MSComm1.CommPort = vNewValue
            PortOpen = True
        Else
            MSComm1.CommPort = vNewValue
        End If
    End If

End Property
Public Property Get BaudRate() As Long
    BaudRate = MyBaudRate
End Property
Public Property Let BaudRate(ByVal vNewValue As Long)
    If (vNewValue <> MyBaudRate) Then
        If PortOpen Then
            PortOpen = False
            MyBaudRate = vNewValue
            PortOpen = True
        Else
            MyBaudRate = vNewValue
        End If
    End If
End Property

