VERSION 5.00
Begin VB.Form FrmMain 
   Caption         =   "Ru Robot control"
   ClientHeight    =   2460
   ClientLeft      =   1545
   ClientTop       =   2745
   ClientWidth     =   7260
   LinkTopic       =   "Form1"
   ScaleHeight     =   2460
   ScaleWidth      =   7260
   Begin VB.CommandButton BtnREload 
      Caption         =   "ReloadINI"
      Height          =   375
      Left            =   1440
      TabIndex        =   2
      Top             =   120
      Width           =   855
   End
   Begin VB.CheckBox ChkConnect 
      Caption         =   "Connect"
      Height          =   255
      Left            =   2520
      TabIndex        =   1
      Top             =   120
      Width           =   1215
   End
   Begin VB.Timer Timer1 
      Interval        =   55
      Left            =   960
      Top             =   720
   End
   Begin VB.CommandButton BtnDiag 
      Caption         =   "Diagnostics"
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1215
   End
   Begin VB.Menu MNUFile 
      Caption         =   "&file"
      Begin VB.Menu MNUFileExit 
         Caption         =   "&Exit"
      End
   End
   Begin VB.Menu MNU_Tools 
      Caption         =   "&tools"
      Begin VB.Menu MNU_Tools_Diag 
         Caption         =   "&Diagnostics"
      End
      Begin VB.Menu MNU_Tools_Map 
         Caption         =   "&Map"
      End
   End
   Begin VB.Menu MNU_Edit 
      Caption         =   "&Settings"
      Begin VB.Menu MNU_Setting_Settings 
         Caption         =   "&Settings"
      End
   End
End
Attribute VB_Name = "FrmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'Purpose (Program)
'   To control the autonomous robot "RackBot"
'Purpose (Main form)
'   To handle basic control and coordinate functions
'

Dim m_firstTime55 As Boolean
Public WithEvents MySerialPkt As ClsSerialPkt
Attribute MySerialPkt.VB_VarHelpID = -1
Public WithEvents m_EncoderLog As ClsEncoderLog
Attribute m_EncoderLog.VB_VarHelpID = -1

'
Dim IamBusy%
Dim IwantToExit As Boolean
Dim statusCnter%

Dim m_ClsIni As ClsINIFile


'
    
Private Sub Form_Load()
'
    Dim Title$
    Title$ = "RackBot Control" & " V" & App.Major & "," & App.Minor & "," & App.Revision
    If App.PrevInstance Then
        Call AppActivate(Title$)
        End
    End If
    Me.Caption = Title$
    
    Set MySerialPkt = New ClsSerialPkt
    Set m_EncoderLog = New ClsEncoderLog
    
    Set m_ClsIni = New ClsINIFile
    Call BtnREload_Click
       
    m_EncoderLog.filename = App.Path & "/" & "RBEncLog.ELG"
        
    g_RegName$ = "BillArden\RackBot"
    
    Me.Left = GetSetting(g_RegName$, "Main", "Left", 1)
    Me.Top = GetSetting(g_RegName$, "Main", "Top", 1)
    Me.Width = GetSetting(g_RegName$, "Main", "Width", 7000)
    Me.Height = GetSetting(g_RegName$, "Main", "Height", 6000)
    
    ChkConnect.Value = Val(GetSetting(g_RegName$, "Comm", "PortOpen", 1))
    

    m_firstTime55 = True
    IamBusy% = False
    
    FrmMap.Show
End Sub
Private Sub BtnREload_Click()
    Call m_ClsIni.FileLoad(App.Path & "/" & App.EXEName)
    g_BotWidth! = Val(m_ClsIni.GetString("Robot", "Width", "1"))
    g_BotLenght! = Val(m_ClsIni.GetString("Robot", "Lenght", "1"))
    g_BotHeight! = Val(m_ClsIni.GetString("Robot", "Height", "1"))
    g_BotEncoderR# = Val(m_ClsIni.GetString("Robot", "RightCPI", "1"))
    g_BotEncoderL# = Val(m_ClsIni.GetString("Robot", "LeftCPI", "1"))
    g_BotWheelDistance# = Val(m_ClsIni.GetString("Robot", "WheelDistance", "1"))
End Sub


Private Sub Form_Unload(Cancel As Integer)
'
    If IamBusy% Then
        Cancel = True
        IwantToExit = True
        IamBusy% = False
        Exit Sub
    End If
    If Me.WindowState = vbNormal Then 'numbers are not valid if minimized
        Call SaveSetting(g_RegName$, "Main", "Left", Me.Left)
        Call SaveSetting(g_RegName$, "Main", "Top", Me.Top)
        Call SaveSetting(g_RegName$, "Main", "Width", Me.Width)
        Call SaveSetting(g_RegName$, "Main", "Height", Me.Height)
    End If
    
    
    Call SaveSetting(g_RegName$, "Comm", "PortOpen", Str$(ChkConnect.Value))
    
    While (Forms.Count > 1) 'unload everyone else
        If (Forms(0) Is Me) Then Unload Forms(1) Else Unload Forms(0)
        DoEvents
    Wend
    
    Set m_ClsIni = Nothing
    Set m_EncoderLog = Nothing
    Set MySerialPkt = Nothing
    
End Sub

Private Sub MNU_Setting_Settings_Click()
    FrmSettings.Show
End Sub

Private Sub MNU_Tools_Diag_Click()
    FrmDiag.Show
End Sub
Private Sub BtnDiag_Click()
    FrmDiag.Show
End Sub

Private Sub MNU_Tools_Map_Click()
    FrmMap.Show
End Sub

Private Sub MNUFileExit_Click()
    Unload Me
End Sub

Private Sub MySerialPkt_Timer55()
    '

End Sub

Private Sub Timer1_Timer()
    
    If IwantToExit Then
        Unload Me
        Exit Sub
    End If
    
    If ChkConnect.Value Then
        IamBusy% = True
        If m_firstTime55 Then
            m_firstTime55 = False
            Call MySerialPkt.PortInit(GetSetting(g_RegName$, "Comm", "Port", 1))
        Else
            statusCnter% = statusCnter% + 1
            If statusCnter% > 2 Then
                statusCnter% = 0
                Dim ASocket As Integer, i%
                ASocket = MySerialPkt.SocketOpen(0)
                For i = 1 To 2
                    MySerialPkt.SocketDeviceID(ASocket) = i
                    Call MySerialPkt.CmdGetCustomStatus(ASocket, 1)
                    Call MySerialPkt.SocketWaitComplete(ASocket)
                    If IwantToExit Then Exit For
                Next
                If IwantToExit = False Then
                    Call m_EncoderLog.AddEncoderLog(MySerialPkt.GetDeviceInfoByNum(1, 1), MySerialPkt.GetDeviceInfoByNum(2, 1))
                End If
                Call MySerialPkt.SocketClose(ASocket)
            End If 'statusCnter%
        End If 'first
        IamBusy% = False
    Else
        'If m_firstTime55 = False Then MySerialPkt.PortOpen = False
        'm_firstTime55 = True
    End If 'connect
    
End Sub
